/*----------------------------------------------------------------------------
 Copyright:      GNU
 Author:         MrTip
 Remarks:        
 known Problems: none
 Version:        2013.01.11
 Description:    LED Line Demontration
------------------------------------------------------------------------------*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <stdlib.h>

#include "main.h"
#include "interrupts.h"

#define pwm_max 900

uint16_t line[12];	//jasnosci diod
uint16_t pline[12];	//jasnosci diod
uint16_t pwm_pos = 0;
uint16_t indelay = 100;
uint16_t line_pos = 1;

uint8_t  reset_run = 1;

uint8_t 	jasnosc = 1;
uint8_t 	step 	= 1;
long int	repeat  = 16;		//czas pomidzy zganiciem a wieceniem


inline void j0_p1 (void) { l1_0;  l1_0;  l1_0;  l1_0;  l1_0;  l1_0;  };
inline void j1_p1 (void) { l1_1;  l1_1;  l1_0;  l1_0;  l1_0;  l1_0;  l1_0; l1_0;  l1_0;  l1_0;};
inline void j2_p1 (void) { l1_1;  l1_1;  l1_1;  l1_0;  l1_0;  l1_0;  l1_0; l1_0;  l1_0;  l1_0;};
inline void j3_p1 (void) { l1_1;  l1_1;  l1_1;  l1_1;  l1_0;  l1_0;  l1_0; l1_0;  l1_0;  l1_0;};
inline void j4_p1 (void) { l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_0;  l1_0; l1_0;  l1_0;  l1_0;};
inline void j5_p1 (void) { l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_0; l1_0;  l1_0;  l1_0;};
inline void j6_p1 (void) { l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_1; l1_0;  l1_0;  l1_0;};
inline void j7_p1 (void) { l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_1; l1_1;  l1_0;  l1_0;};
inline void j8_p1 (void) { l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_1;  l1_1; l1_1;  l1_1;  l1_0;};

inline void j0_p2 (void) { l2_0;  l2_0;  l2_0;  l2_0;  l2_0;  l2_0;  };
inline void j1_p2 (void) { l2_1;  l2_1;  l2_0;  l2_0;  l2_0;  l2_0;  l2_0; l2_0;  l2_0;  l2_0;};
inline void j2_p2 (void) { l2_1;  l2_1;  l2_1;  l2_0;  l2_0;  l2_0;  l2_0; l2_0;  l2_0;  l2_0;};
inline void j3_p2 (void) { l2_1;  l2_1;  l2_1;  l2_1;  l2_0;  l2_0;  l2_0; l2_0;  l2_0;  l2_0;};
inline void j4_p2 (void) { l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_0;  l2_0; l2_0;  l2_0;  l2_0;};
inline void j5_p2 (void) { l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_0; l2_0;  l2_0;  l2_0;};
inline void j6_p2 (void) { l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_1; l2_0;  l2_0;  l2_0;};
inline void j7_p2 (void) { l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_1; l2_1;  l2_0;  l2_0;};
inline void j8_p2 (void) { l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_1;  l2_1; l2_1;  l2_1;  l2_0;};

inline void j0_p3 (void) { l3_0;  l3_0;  l3_0;  l3_0;  l3_0;  l3_0;  };
inline void j1_p3 (void) { l3_1;  l3_1;  l3_0;  l3_0;  l3_0;  l3_0;  l3_0; l3_0;  l3_0;  l3_0;};
inline void j2_p3 (void) { l3_1;  l3_1;  l3_1;  l3_0;  l3_0;  l3_0;  l3_0; l3_0;  l3_0;  l3_0;};
inline void j3_p3 (void) { l3_1;  l3_1;  l3_1;  l3_1;  l3_0;  l3_0;  l3_0; l3_0;  l3_0;  l3_0;};
inline void j4_p3 (void) { l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_0;  l3_0; l3_0;  l3_0;  l3_0;};
inline void j5_p3 (void) { l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_0; l3_0;  l3_0;  l3_0;};
inline void j6_p3 (void) { l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_1; l3_0;  l3_0;  l3_0;};
inline void j7_p3 (void) { l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_1; l3_1;  l3_0;  l3_0;};
inline void j8_p3 (void) { l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_1;  l3_1; l3_1;  l3_1;  l3_0;};

inline void j0_p4 (void) { l4_0;  l4_0;  l4_0;  l4_0;  l4_0;  l4_0;  };
inline void j1_p4 (void) { l4_1;  l4_1;  l4_0;  l4_0;  l4_0;  l4_0;  l4_0; l4_0;  l4_0;  l4_0;};
inline void j2_p4 (void) { l4_1;  l4_1;  l4_1;  l4_0;  l4_0;  l4_0;  l4_0; l4_0;  l4_0;  l4_0;};
inline void j3_p4 (void) { l4_1;  l4_1;  l4_1;  l4_1;  l4_0;  l4_0;  l4_0; l4_0;  l4_0;  l4_0;};
inline void j4_p4 (void) { l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_0;  l4_0; l4_0;  l4_0;  l4_0;};
inline void j5_p4 (void) { l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_0; l4_0;  l4_0;  l4_0;};
inline void j6_p4 (void) { l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_1; l4_0;  l4_0;  l4_0;};
inline void j7_p4 (void) { l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_1; l4_1;  l4_0;  l4_0;};
inline void j8_p4 (void) { l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_1;  l4_1; l4_1;  l4_1;  l4_0;};

inline void j0_p5 (void) { l5_0;  l5_0;  l5_0;  l5_0;  l5_0;  l5_0;  };
inline void j1_p5 (void) { l5_1;  l5_1;  l5_0;  l5_0;  l5_0;  l5_0;  l5_0; l5_0;  l5_0;  l5_0;};
inline void j2_p5 (void) { l5_1;  l5_1;  l5_1;  l5_0;  l5_0;  l5_0;  l5_0; l5_0;  l5_0;  l5_0;};
inline void j3_p5 (void) { l5_1;  l5_1;  l5_1;  l5_1;  l5_0;  l5_0;  l5_0; l5_0;  l5_0;  l5_0;};
inline void j4_p5 (void) { l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_0;  l5_0; l5_0;  l5_0;  l5_0;};
inline void j5_p5 (void) { l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_0; l5_0;  l5_0;  l5_0;};
inline void j6_p5 (void) { l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_1; l5_0;  l5_0;  l5_0;};
inline void j7_p5 (void) { l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_1; l5_1;  l5_0;  l5_0;};
inline void j8_p5 (void) { l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_1;  l5_1; l5_1;  l5_1;  l5_0;};

inline void j0_p6 (void) { l6_0;  l6_0;  l6_0;  l6_0;  l6_0;  l6_0;  };
inline void j1_p6 (void) { l6_1;  l6_1;  l6_0;  l6_0;  l6_0;  l6_0;  l6_0; l6_0;  l6_0;  l6_0;};
inline void j2_p6 (void) { l6_1;  l6_1;  l6_1;  l6_0;  l6_0;  l6_0;  l6_0; l6_0;  l6_0;  l6_0;};
inline void j3_p6 (void) { l6_1;  l6_1;  l6_1;  l6_1;  l6_0;  l6_0;  l6_0; l6_0;  l6_0;  l6_0;};
inline void j4_p6 (void) { l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_0;  l6_0; l6_0;  l6_0;  l6_0;};
inline void j5_p6 (void) { l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_0; l6_0;  l6_0;  l6_0;};
inline void j6_p6 (void) { l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_1; l6_0;  l6_0;  l6_0;};
inline void j7_p6 (void) { l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_1; l6_1;  l6_0;  l6_0;};
inline void j8_p6 (void) { l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_1;  l6_1; l6_1;  l6_1;  l6_0;};

inline void j0_p7 (void) { l7_0;  l7_0;  l7_0;  l7_0;  l7_0;  l7_0;  };
inline void j1_p7 (void) { l7_1;  l7_1;  l7_0;  l7_0;  l7_0;  l7_0;  l7_0; l7_0;  l7_0;  l7_0;};
inline void j2_p7 (void) { l7_1;  l7_1;  l7_1;  l7_0;  l7_0;  l7_0;  l7_0; l7_0;  l7_0;  l7_0;};
inline void j3_p7 (void) { l7_1;  l7_1;  l7_1;  l7_1;  l7_0;  l7_0;  l7_0; l7_0;  l7_0;  l7_0;};
inline void j4_p7 (void) { l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_0;  l7_0; l7_0;  l7_0;  l7_0;};
inline void j5_p7 (void) { l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_0; l7_0;  l7_0;  l7_0;};
inline void j6_p7 (void) { l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_1; l7_0;  l7_0;  l7_0;};
inline void j7_p7 (void) { l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_1; l7_1;  l7_0;  l7_0;};
inline void j8_p7 (void) { l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_1;  l7_1; l7_1;  l7_1;  l7_0;};

inline void j0_p8 (void) { l8_0;  l8_0;  l8_0;  l8_0;  l8_0;  l8_0;  };
inline void j1_p8 (void) { l8_1;  l8_1;  l8_0;  l8_0;  l8_0;  l8_0;  l8_0; l8_0;  l8_0;  l8_0;};
inline void j2_p8 (void) { l8_1;  l8_1;  l8_1;  l8_0;  l8_0;  l8_0;  l8_0; l8_0;  l8_0;  l8_0;};
inline void j3_p8 (void) { l8_1;  l8_1;  l8_1;  l8_1;  l8_0;  l8_0;  l8_0; l8_0;  l8_0;  l8_0;};
inline void j4_p8 (void) { l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_0;  l8_0; l8_0;  l8_0;  l8_0;};
inline void j5_p8 (void) { l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_0; l8_0;  l8_0;  l8_0;};
inline void j6_p8 (void) { l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_1; l8_0;  l8_0;  l8_0;};
inline void j7_p8 (void) { l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_1; l8_1;  l8_0;  l8_0;};
inline void j8_p8 (void) { l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_1;  l8_1; l8_1;  l8_1;  l8_0;};

inline void j0_p9 (void) { l9_0;  l9_0;  l9_0;  l9_0;  l9_0;  l9_0;  };
inline void j1_p9 (void) { l9_1;  l9_1;  l9_0;  l9_0;  l9_0;  l9_0;  l9_0; l9_0;  l9_0;  l9_0;};
inline void j2_p9 (void) { l9_1;  l9_1;  l9_1;  l9_0;  l9_0;  l9_0;  l9_0; l9_0;  l9_0;  l9_0;};
inline void j3_p9 (void) { l9_1;  l9_1;  l9_1;  l9_1;  l9_0;  l9_0;  l9_0; l9_0;  l9_0;  l9_0;};
inline void j4_p9 (void) { l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_0;  l9_0; l9_0;  l9_0;  l9_0;};
inline void j5_p9 (void) { l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_0; l9_0;  l9_0;  l9_0;};
inline void j6_p9 (void) { l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_1; l9_0;  l9_0;  l9_0;};
inline void j7_p9 (void) { l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_1; l9_1;  l9_0;  l9_0;};
inline void j8_p9 (void) { l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_1;  l9_1; l9_1;  l9_1;  l9_0;};

inline void j0_p10 (void) { l10_0;  l10_0;  l10_0;  l10_0;  l10_0;  l10_0;  };
inline void j1_p10 (void) { l10_1;  l10_1;  l10_0;  l10_0;  l10_0;  l10_0;  l10_0; l10_0;  l10_0;  l10_0;};
inline void j2_p10 (void) { l10_1;  l10_1;  l10_1;  l10_0;  l10_0;  l10_0;  l10_0; l10_0;  l10_0;  l10_0;};
inline void j3_p10 (void) { l10_1;  l10_1;  l10_1;  l10_1;  l10_0;  l10_0;  l10_0; l10_0;  l10_0;  l10_0;};
inline void j4_p10 (void) { l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_0;  l10_0; l10_0;  l10_0;  l10_0;};
inline void j5_p10 (void) { l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_0; l10_0;  l10_0;  l10_0;};
inline void j6_p10 (void) { l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_1; l10_0;  l10_0;  l10_0;};
inline void j7_p10 (void) { l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_1; l10_1;  l10_0;  l10_0;};
inline void j8_p10 (void) { l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_1;  l10_1; l10_1;  l10_1;  l10_0;};

inline void j0_p11 (void) { l11_0;  l11_0;  l11_0;  l11_0;  l11_0;  l11_0;  };
inline void j1_p11 (void) { l11_1;  l11_1;  l11_0;  l11_0;  l11_0;  l11_0;  l11_0; l11_0;  l11_0;  l11_0;};
inline void j2_p11 (void) { l11_1;  l11_1;  l11_1;  l11_0;  l11_0;  l11_0;  l11_0; l11_0;  l11_0;  l11_0;};
inline void j3_p11 (void) { l11_1;  l11_1;  l11_1;  l11_1;  l11_0;  l11_0;  l11_0; l11_0;  l11_0;  l11_0;};
inline void j4_p11 (void) { l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_0;  l11_0; l11_0;  l11_0;  l11_0;};
inline void j5_p11 (void) { l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_0; l11_0;  l11_0;  l11_0;};
inline void j6_p11 (void) { l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_1; l11_0;  l11_0;  l11_0;};
inline void j7_p11 (void) { l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_1; l11_1;  l11_0;  l11_0;};
inline void j8_p11 (void) { l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_1;  l11_1; l11_1;  l11_1;  l11_0;};

void pwm (void)
{
		long int l;
		uint16_t s,i;

	if (jasnosc==1)
	{
		if ( line[1]>pwm_pos) j1_p1();  else j0_p1();
		if ( line[2]>pwm_pos) j1_p2();  else j0_p2();
		if ( line[3]>pwm_pos) j1_p3();  else j0_p3();
		if ( line[4]>pwm_pos) j1_p4();  else j0_p4();
		if ( line[5]>pwm_pos) j1_p5();  else j0_p5();
		if ( line[6]>pwm_pos) j1_p6();  else j0_p6();
		if ( line[7]>pwm_pos) j1_p7();  else j0_p7();
		if ( line[8]>pwm_pos) j1_p8();  else j0_p8();
		if ( line[9]>pwm_pos) j1_p9();  else j0_p9();
		if (line[10]>pwm_pos) j1_p10(); else j0_p10();
		if (line[11]>pwm_pos) j1_p11(); else j0_p11();
	}
	if (jasnosc==2)
	{
		if ( line[1]>pwm_pos) j2_p1();  else j0_p1();
		if ( line[2]>pwm_pos) j2_p2();  else j0_p2();
		if ( line[3]>pwm_pos) j2_p3();  else j0_p3();
		if ( line[4]>pwm_pos) j2_p4();  else j0_p4();
		if ( line[5]>pwm_pos) j2_p5();  else j0_p5();
		if ( line[6]>pwm_pos) j2_p6();  else j0_p6();
		if ( line[7]>pwm_pos) j2_p7();  else j0_p7();
		if ( line[8]>pwm_pos) j2_p8();  else j0_p8();
		if ( line[9]>pwm_pos) j2_p9();  else j0_p9();
		if (line[10]>pwm_pos) j2_p10(); else j0_p10();
		if (line[11]>pwm_pos) j2_p11(); else j0_p11();
	}
	if (jasnosc==3)
	{
		if ( line[1]>pwm_pos) j3_p1();  else j0_p1();
		if ( line[2]>pwm_pos) j3_p2();  else j0_p2();
		if ( line[3]>pwm_pos) j3_p3();  else j0_p3();
		if ( line[4]>pwm_pos) j3_p4();  else j0_p4();
		if ( line[5]>pwm_pos) j3_p5();  else j0_p5();
		if ( line[6]>pwm_pos) j3_p6();  else j0_p6();
		if ( line[7]>pwm_pos) j3_p7();  else j0_p7();
		if ( line[8]>pwm_pos) j3_p8();  else j0_p8();
		if ( line[9]>pwm_pos) j3_p9();  else j0_p9();
		if (line[10]>pwm_pos) j3_p10(); else j0_p10();
		if (line[11]>pwm_pos) j3_p11(); else j0_p11();
	}
	if (jasnosc==4)
	{
		if ( line[1]>pwm_pos) j4_p1();  else j0_p1();
		if ( line[2]>pwm_pos) j4_p2();  else j0_p2();
		if ( line[3]>pwm_pos) j4_p3();  else j0_p3();
		if ( line[4]>pwm_pos) j4_p4();  else j0_p4();
		if ( line[5]>pwm_pos) j4_p5();  else j0_p5();
		if ( line[6]>pwm_pos) j4_p6();  else j0_p6();
		if ( line[7]>pwm_pos) j4_p7();  else j0_p7();
		if ( line[8]>pwm_pos) j4_p8();  else j0_p8();
		if ( line[9]>pwm_pos) j4_p9();  else j0_p9();
		if (line[10]>pwm_pos) j4_p10(); else j0_p10();
		if (line[11]>pwm_pos) j4_p11(); else j0_p11();
	}
	if (jasnosc==5)
	{
		if ( line[1]>pwm_pos) j5_p1();  else j0_p1();
		if ( line[2]>pwm_pos) j5_p2();  else j0_p2();
		if ( line[3]>pwm_pos) j5_p3();  else j0_p3();
		if ( line[4]>pwm_pos) j5_p4();  else j0_p4();
		if ( line[5]>pwm_pos) j5_p5();  else j0_p5();
		if ( line[6]>pwm_pos) j5_p6();  else j0_p6();
		if ( line[7]>pwm_pos) j5_p7();  else j0_p7();
		if ( line[8]>pwm_pos) j5_p8();  else j0_p8();
		if ( line[9]>pwm_pos) j5_p9();  else j0_p9();
		if (line[10]>pwm_pos) j5_p10(); else j0_p10();
		if (line[11]>pwm_pos) j5_p11(); else j0_p11();
	}
	if (jasnosc==6)
	{
		if ( line[1]>pwm_pos) j6_p1();  else j0_p1();
		if ( line[2]>pwm_pos) j6_p2();  else j0_p2();
		if ( line[3]>pwm_pos) j6_p3();  else j0_p3();
		if ( line[4]>pwm_pos) j6_p4();  else j0_p4();
		if ( line[5]>pwm_pos) j6_p5();  else j0_p5();
		if ( line[6]>pwm_pos) j6_p6();  else j0_p6();
		if ( line[7]>pwm_pos) j6_p7();  else j0_p7();
		if ( line[8]>pwm_pos) j6_p8();  else j0_p8();
		if ( line[9]>pwm_pos) j6_p9();  else j0_p9();
		if (line[10]>pwm_pos) j6_p10(); else j0_p10();
		if (line[11]>pwm_pos) j6_p11(); else j0_p11();
	}
	if (jasnosc==7)
	{
		if ( line[1]>pwm_pos) j7_p1();  else j0_p1();
		if ( line[2]>pwm_pos) j7_p2();  else j0_p2();
		if ( line[3]>pwm_pos) j7_p3();  else j0_p3();
		if ( line[4]>pwm_pos) j7_p4();  else j0_p4();
		if ( line[5]>pwm_pos) j7_p5();  else j0_p5();
		if ( line[6]>pwm_pos) j7_p6();  else j0_p6();
		if ( line[7]>pwm_pos) j7_p7();  else j0_p7();
		if ( line[8]>pwm_pos) j7_p8();  else j0_p8();
		if ( line[9]>pwm_pos) j7_p9();  else j0_p9();
		if (line[10]>pwm_pos) j7_p10(); else j0_p10();
		if (line[11]>pwm_pos) j7_p11(); else j0_p11();
	}
	if (jasnosc==8)
	{
		if ( line[1]>pwm_pos) j8_p1();  else j0_p1();
		if ( line[2]>pwm_pos) j8_p2();  else j0_p2();
		if ( line[3]>pwm_pos) j8_p3();  else j0_p3();
		if ( line[4]>pwm_pos) j8_p4();  else j0_p4();
		if ( line[5]>pwm_pos) j8_p5();  else j0_p5();
		if ( line[6]>pwm_pos) j8_p6();  else j0_p6();
		if ( line[7]>pwm_pos) j8_p7();  else j0_p7();
		if ( line[8]>pwm_pos) j8_p8();  else j0_p8();
		if ( line[9]>pwm_pos) j8_p9();  else j0_p9();
		if (line[10]>pwm_pos) j8_p10(); else j0_p10();
		if (line[11]>pwm_pos) j8_p11(); else j0_p11();
	}
	pwm_pos++; if (pwm_pos>pwm_max) pwm_pos=0;

	if (krok()==0)
	{
		step++; if (step>16) step=1;
		while (krok()==0)
		{
			if (step==1)  {          j3_p1();}
			if (step==2)  { j3_p1(); j3_p2();}
			if (step==3)  {          j3_p2();}
			if (step==4)  { j3_p2(); j3_p3();}
			if (step==5)  {          j3_p3();}
			if (step==6)  { j3_p3(); j3_p4();}
			if (step==7)  {          j3_p4();}
			if (step==8)  { j3_p4(); j3_p5();}
			if (step==9)  {          j3_p5();}
			if (step==10) { j3_p5(); j3_p6();}
			if (step==11) {          j3_p6();}
			if (step==12) {          j3_p7();}
			if (step==13) {          j3_p8();}
			if (step==14) {          j3_p9();}
			if (step==15) {          j3_p10();}
			if (step==16) {          j3_p11();}
			j0_p1();j0_p2();j0_p3();j0_p4();j0_p5();j0_p6();j0_p7();j0_p8();j0_p9();j0_p10();j0_p11();
		}
		indelay=0; 
		line_pos=1;
		for (l=0;l<1000000;l++){asm("nop");};
		if (krok()!=0) eeprom_write_byte((uint16_t*)32,step); 

	}

	if (jasn()==0)
	{
		jasnosc++; if (jasnosc>8) jasnosc=2;
		while (jasn()==0)
		{
			if (jasnosc==1)  { j3_p1();}
			if (jasnosc==2)  { j3_p2();}
			if (jasnosc==3)  { j3_p3();}
			if (jasnosc==4)  { j3_p4();}
			if (jasnosc==5)  { j3_p5();}
			if (jasnosc==6)  { j3_p6();}
			if (jasnosc==7)  { j3_p7();}
			if (jasnosc==8)  { j3_p8();}
			j0_p1();j0_p2();j0_p3();j0_p4();j0_p5();j0_p6();j0_p7();j0_p8();j0_p9();j0_p10();j0_p11();
		}
		indelay=0; 
		line_pos=1;
		for (l=0;l<1000000;l++){asm("nop");};
		if (jasn()!=0) eeprom_write_byte((uint16_t*)48,jasnosc); 
	}

	if (powt()==0)
	{
		repeat++; if (repeat>16) repeat=1;
		while (powt()==0)
		{
			if (repeat==1)  {          j3_p1();}
			if (repeat==2)  { j3_p1(); j3_p2();}
			if (repeat==3)  {          j3_p2();}
			if (repeat==4)  { j3_p2(); j3_p3();}
			if (repeat==5)  {          j3_p3();}
			if (repeat==6)  { j3_p3(); j3_p4();}
			if (repeat==7)  {          j3_p4();}
			if (repeat==8)  { j3_p4(); j3_p5();}
			if (repeat==9)  {          j3_p5();}
			if (repeat==10) { j3_p5(); j3_p6();}
			if (repeat==11) {          j3_p6();}
			if (repeat==12) {          j3_p7();}
			if (repeat==13) {          j3_p8();}
			if (repeat==14) {          j3_p9();}
			if (repeat==15) {          j3_p10();}
			if (repeat==16) {          j3_p11();}
			j0_p1();j0_p2();j0_p3();j0_p4();j0_p5();j0_p6();j0_p7();j0_p8();j0_p9();j0_p10();j0_p11();
		}
		indelay=0; 
		line_pos=1;
		for (l=0;l<1000000;l++){asm("nop");};
		if (powt()!=0) eeprom_write_byte((uint16_t*)16,repeat); 

	}

}


int main(void)
{
	long int l;
	uint16_t s,i;

    uint16_t w_epr;
	uint8_t b_epr;

	reset_run=1;
	IO_Init();

	for (l=0;l<1000000;l++){asm("nop");};
	for (l=0;l<1000000;l++){asm("nop");};

//while (powt()!=0){}; for (l=0;l<1000000;l++){asm("nop");};for (l=0;l<1000000;l++){asm("nop");};

    jasnosc = eeprom_read_byte((uint16_t*)48); 
    repeat  = eeprom_read_byte((uint16_t*)16); 
    step    = eeprom_read_byte((uint16_t*)32); 

	if (jasnosc>8) jasnosc=2;
	if (repeat>16) repeat=2;
	if (step>16) step=2;

	for (i=0;i<12;i++) line[i]=0;
	for (i=0;i<12;i++) pline[i]=0;

//	while (jasn()!=0){}; for (l=0;l<1000000;l++){asm("nop");};for (l=0;l<1000000;l++){asm("nop");};



	while(1)
	{
		pwm();
		indelay++; if (indelay>(step*10))
			{ 
				indelay=0; 

				
				line[line_pos]++; 
				if (line[line_pos]>pwm_max) line_pos++;
				
				if (line_pos>11) 
				{
					line_pos=1;
					for (l=0;l<(repeat*10000);l++) { pwm();	for (i=0;i<60;i++){};}
					for (i=0;i<12;i++) line[i]=0;
					for (l=0;l<(repeat*10000);l++) { pwm();}
					indelay=0;
					reset_run=0;
				}
			}
	}
 
}
