
#ifndef _CLIENT_H
	#define _CLIENT_H

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <stdlib.h>

#define _l1		2	//PB2	//out
#define _l2		1	//PB1	//out
#define _l3		0	//PB0	//out
#define _l4		7	//PD7	//out
#define _l5		6	//PD6	//out
#define _l6		5	//PD5	//out
#define _l7		4	//PD4	//out
#define _l8		3	//PD3	//out
#define _l9		2	//PD2	//out
#define _l10	1	//PD1	//out
#define _l11	0	//PD0	//out

#define port_l1		PORTB	//out
#define port_l2		PORTB	//out
#define port_l3		PORTB	//out
#define port_l4		PORTD	//out
#define port_l5		PORTD	//out
#define port_l6		PORTD	//out
#define port_l7		PORTD	//out
#define port_l8		PORTD	//out
#define port_l9		PORTD	//out
#define port_l10	PORTD	//out
#define port_l11	PORTD	//out

#define ddr_l1		DDRB	//out
#define ddr_l2		DDRB	//out
#define ddr_l3		DDRB	//out
#define ddr_l4		DDRD	//out
#define ddr_l5		DDRD	//out
#define ddr_l6		DDRD	//out
#define ddr_l7		DDRD	//out
#define ddr_l8		DDRD	//out
#define ddr_l9		DDRD	//out
#define ddr_l10		DDRD	//out
#define ddr_l11		DDRD	//out
	
#define	_krok	5	//PC5	//in
#define	_powt	4	//PC4	//in
#define	_jasn	3	//PC3	//in
#define	_adc	0	//PC0	//in


#define	port_krok	PORTC	//in
#define	port_powt	PORTC	//in
#define	port_jasn	PORTC	//in
#define	port_adc	PORTC	//in

#define	ddr_krok	DDRC	//in
#define	ddr_powt	DDRC	//in
#define	ddr_jasn	DDRC	//in
#define	ddr_adc		DDRC	//in

#define	pin_krok	PINC	//in
#define	pin_powt	PINC	//in
#define	pin_jasn	PINC	//in
#define	pin_adc		PINC	//in
	
//----------------------------------------------------------------------------------------------------------------------------------
static inline void IO_Init(void)
{
	ddr_l1 |= (1<<_l1); port_l1 &= ~(1<<_l1);
	ddr_l2 |= (1<<_l2); port_l2 &= ~(1<<_l2);
	ddr_l3 |= (1<<_l3); port_l3 &= ~(1<<_l3);
	ddr_l4 |= (1<<_l4); port_l4 &= ~(1<<_l4);
	ddr_l5 |= (1<<_l5); port_l5 &= ~(1<<_l5);
	ddr_l6 |= (1<<_l6); port_l6 &= ~(1<<_l6);
	ddr_l7 |= (1<<_l7); port_l7 &= ~(1<<_l7);
	ddr_l8 |= (1<<_l8); port_l8 &= ~(1<<_l8);
	ddr_l9 |= (1<<_l9); port_l9 &= ~(1<<_l9);
	ddr_l10 |= (1<<_l10); port_l10 &= ~(1<<_l10);
	ddr_l11 |= (1<<_l11); port_l11 &= ~(1<<_l11);

	ddr_krok &= ~(1<<_krok); port_krok |= (1<<_krok);	//pull-up
	ddr_powt &= ~(1<<_powt); port_powt |= (1<<_powt);	//pull-up
	ddr_jasn &= ~(1<<_jasn); port_jasn |= (1<<_jasn);	//pull-up
	ddr_adc &= ~(1<<_adc); port_adc |= (1<<_adc);	//pull-up

}
//----------------------------------------------------------------------------------------------------------------------------------
#define l1_1 port_l1 |=  (1<<_l1)
#define l1_0 port_l1 &= ~(1<<_l1)
#define l2_1 port_l2 |=  (1<<_l2)
#define l2_0 port_l2 &= ~(1<<_l2)
#define l3_1 port_l3 |=  (1<<_l3)
#define l3_0 port_l3 &= ~(1<<_l3)
#define l4_1 port_l4 |=  (1<<_l4)
#define l4_0 port_l4 &= ~(1<<_l4)
#define l5_1 port_l5 |=  (1<<_l5)
#define l5_0 port_l5 &= ~(1<<_l5)
#define l6_1 port_l6 |=  (1<<_l6)
#define l6_0 port_l6 &= ~(1<<_l6)
#define l7_1 port_l7 |=  (1<<_l7)
#define l7_0 port_l7 &= ~(1<<_l7)
#define l8_1 port_l8 |=  (1<<_l8)
#define l8_0 port_l8 &= ~(1<<_l8)
#define l9_1 port_l9 |=  (1<<_l9)
#define l9_0 port_l9 &= ~(1<<_l9)
#define l10_1 port_l10 |=  (1<<_l10)
#define l10_0 port_l10 &= ~(1<<_l10)
#define l11_1 port_l11 |=  (1<<_l11)
#define l11_0 port_l11 &= ~(1<<_l11)

static inline void l1(char state){ if (state==1) { port_l1 |= (1<<_l1);} else { port_l1 &= ~(1<<_l1);}}
static inline void l2(char state){ if (state==1) { port_l2 |= (1<<_l2);} else { port_l2 &= ~(1<<_l2);}}
static inline void l3(char state){ if (state==1) { port_l3 |= (1<<_l3);} else { port_l3 &= ~(1<<_l3);}}
static inline void l4(char state){ if (state==1) { port_l4 |= (1<<_l4);} else { port_l4 &= ~(1<<_l4);}}
static inline void l5(char state){ if (state==1) { port_l5 |= (1<<_l5);} else { port_l5 &= ~(1<<_l5);}}
static inline void l6(char state){ if (state==1) { port_l6 |= (1<<_l6);} else { port_l6 &= ~(1<<_l6);}}
static inline void l7(char state){ if (state==1) { port_l7 |= (1<<_l7);} else { port_l7 &= ~(1<<_l7);}}
static inline void l8(char state){ if (state==1) { port_l8 |= (1<<_l8);} else { port_l8 &= ~(1<<_l8);}}
static inline void l9(char state){ if (state==1) { port_l9 |= (1<<_l9);} else { port_l9 &= ~(1<<_l9);}}
static inline void l10(char state){ if (state==1) { port_l10 |= (1<<_l10);} else { port_l10 &= ~(1<<_l10);}}
static inline void l11(char state){ if (state==1) { port_l11 |= (1<<_l11);} else { port_l11 &= ~(1<<_l11);}}

static inline unsigned char krok(void) {return ((pin_krok&(1<<_krok))>>_krok);}
static inline unsigned char powt(void) {return ((pin_powt&(1<<_powt))>>_powt);}//Input
static inline unsigned char jasn(void) {return ((pin_jasn&(1<<_jasn))>>_jasn);}//Input
static inline unsigned char getadc(void) {return (pin_adc&1);}//Input

//----------------------------------------------------------------------------------------------------------------------------------
#endif
